"use strict";

var _path = require("path");

var path = _interopRequireWildcard(_path);

var _webpack = require("webpack");

var webpack = _interopRequireWildcard(_webpack);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

module.exports = function (config) {
  return new Promise(function (resolve) {
    const cwd = process.cwd();
    const paths = {
      // XXX: not correct if the user changes the default
      antwarConfig: path.join(cwd, "antwar.config.js"),
      config: path.join(__dirname, "config_entry.js"),
      parent: path.join(__dirname, "..")
    };

    resolve({
      resolve: {
        alias: {
          antwarConfig: paths.antwarConfig,
          config: paths.config
        },
        extensions: [".js", ".jsx", ".json"],
        modules: [path.join(cwd, "node_modules"), "node_modules"]
      },
      resolveLoader: {
        modules: [cwd, path.join(paths.parent, "node_modules"), "node_modules"]
      },
      plugins: [new webpack.DefinePlugin({
        __DEV__: JSON.stringify(JSON.parse(config.buildDev)),
        __ENV__: JSON.stringify(config.environment),
        "process.env": {
          NODE_ENV: JSON.stringify("dev")
        }
      })]
    });
  });
};